clear
clc

soubor_vstup = input('Zadej vstupn m soubor (lpe bez ppony): ','s');
if (soubor_vstup(end-1:end) == '.m')  soubor_vstup = soubor_vstup(1:end-2); end
%soubor_vstup = 'petr_smery';
eval(soubor_vstup);
addpath funkce;
data; % naten spolench dat

% pevod mench smr na radiny
smery_na_cil = smery(1:2,1:3)*[1;0.01;0.0001] *pi/200;
smery_rad = smery(3:end,1:3)*[1;0.01;0.0001] *pi/200;

% pevod ostatnch veliin na radiny
lambda0_rad = lambda0 * [3600;60;1] *pi/3600/180;
fi0_rad = fi0 * [3600;60;1] *pi/3600/180;
alfa0 = RA0 * [3600;60;1] *pi/43200;
delta0 = DEC0 * [3600;60;1] *pi/3600/180;
alfa1 = RA1 * [3600;60;1] *pi/43200;
delta1 = DEC1 * [3600;60;1] *pi/3600/180;

% as na UT1 pro den 28.04.2004 (h m s) a potom na radiny
[m,n] = size(smery_rad);
UT1 = zeros(m,3);
for ii = 1:m
    UT1(ii,:) = (smery(ii+2,4:6) + t0 + [-TIMEZONE 0 DUT1]);
end

UT1_rad = UT1*[3600;60;1] *pi/43200;
S0_rad = S0*[3600;60;1] *pi/43200;

% interpolace alfa delta
dalfa = alfa1 - alfa0;
ddelta = delta1 - delta0;
TT = UT1_rad/2/pi - DUT1/86400 + TT_UTC/86400;  % terestrick as ve zlomku dne
alfa = alfa0 + dalfa*TT;
delta = delta0 + ddelta*TT;


% vpoet hodinovch hl Slunce
hodin_uhel = UT1_rad*1.00273790935 + S0_rad + lambda0_rad - alfa;

% vpoet azimut Slunce
azimuty = atan2(cos(delta).*sin(hodin_uhel),-cos(fi0_rad).*sin(delta) + sin(fi0_rad).*cos(delta).*cos(hodin_uhel));

% aberace na azimut
zenitky = asin(cos(delta).*sin(hodin_uhel)./sin(azimuty));
aberace = aberace_a(fi0_rad,azimuty,zenitky);
azimuty = azimuty + aberace;

% paralaxa na azimut
paralaxa = paralaxa_a(fi0_rad,azimuty,zenitky);
azimuty = azimuty + paralaxa;

% vpoet azimutu Svatho Vta
smery_na_cil_rep = repmat(smery_na_cil,length(smery_rad)/2,1);
uhly = smery_rad - smery_na_cil_rep;
uhel = mean(uhly);
azimut_Slunce = mean(azimuty);

konv_rad = merid_konv*[3600;60;1]*pi/3600/180;  % meridinov konvergence
smer_korekce_rad = smer_korekce*pi/3600/180;
azimuty_Vita = azimuty - uhly + 2*pi;
azimut_Vita = azimut_Slunce - uhel + 2*pi;
smernik_jtsk = atan2(sv_Vit_yx(1)-stanovisko_yx(1),sv_Vit_yx(2)-stanovisko_yx(2)) + 2*pi;
smernik_astr = azimut_Vita + konv_rad + smer_korekce_rad;

rozdil_smerniku = smernik_astr - smernik_jtsk;


% vpis vsledk
soubor = input('Vstupn soubor (nic pro vpis na obrazovku): ','s');
if isempty(soubor)
    fprintf('\n');
    file = 1;
else
    file = fopen(soubor,'wt');
end

fprintf(file,'Vpoet azimutu a smrnku sv. Vta z men na Slunce (pedmt KG10)\n');
fprintf(file,'Datum vpotu: %s\n',nyni);
fprintf(file,'Datum men:  %02d.%02d.%04d\n',DATUM(3),DATUM(2),DATUM(1));
fprintf(file,'asov zona UTC %+.0f h\n',TIMEZONE);
fprintf(file,'Hodnota DUT1 = %+.5f s\n',DUT1);
fprintf(file,'Nzev vstupnho souboru: %s\n',soubor_vstup);
fprintf(file,'\nSouadnice stanoviska [X Y] (S-JTSK): %.3f  %.3f\n',stanovisko_yx(2),stanovisko_yx(1));
fprintf(file,'Souadnice sv. Vta [X Y] (S-JTSK):   %.3f  %.3f\n',sv_Vit_yx(2),sv_Vit_yx(1));
fprintf(file,'Piblin souadnice stanoviska (fi lambda): %s  %s\n',dmsr(fi0_rad,2),dmsr(lambda0_rad,2));
UT1_rad = UT1*[3600;60;1] *pi/3600/12;
fprintf(file,'\nas men UT1, Terestrick as TT, hodinov hel t:\n');
for ii = 1:m
    fprintf(file,'%s     %s     %s\n',hmsr(UT1_rad(ii),2),hmsr(TT(ii)*2*pi,2),hms2r(hodin_uhel(ii),3));
end
fprintf(file,'\nAberace, Paralaxa na azimuty:\n');
for ii = 1:m
    fprintf(file,'%s     %s\n',dmsr(aberace(ii),6),dmsr(paralaxa(ii),9));
end
fprintf(file,'\nJednotliv azimuty Slunce; hly mezi Vtem a Sluncem;  azimuty sv. Vta (jednotliv nemaj dn vznam):\n');
for ii = 1:m
    fprintf(file,'%s     %s     %s\n',dmsr(azimuty(ii),4),dmsr(uhly(ii),4),dmsr(azimuty_Vita(ii),4));
end

fprintf(file,'\nVsledn azimut sv. Vta:            %s\n',dmsr(azimut_Vita,3));
fprintf(file,'Smrnk vypoten ze souadnic JTSK: %s\n',dmsr(smernik_jtsk,3));
fprintf(file,'Smrnk uren z men na Slunce:   %s\n',dmsr(smernik_astr,3));
fprintf(file,'Rozdl smrnk:                      %s\n',dmsr(rozdil_smerniku,3));

if ~isempty(soubor)
    fclose(file);
else
    fprintf('\n');
end

%EOF