clear
clc


soubor_vstup = input('Zadej vstupn m soubor (lpe bez ppony): ','s');
if (soubor_vstup(end-1:end) == '.m')  soubor_vstup = soubor_vstup(1:end-2); end
%soubor_vstup = 'petr_zenitky';
eval(soubor_vstup);
addpath funkce;
data; % naten spolench dat

% pevod mench zenitek na radiny (ve do prvn polohy)
zenitky_rad = zenitky(:,1:3)*[1;0.01;0.0001] *pi/200;
zenitky_rad(zenitky_rad > pi) = 2*pi - zenitky_rad(zenitky_rad > pi);

% pevod ostatnch veliin na radiny
lambda0_rad = lambda0 * [3600;60;1] *pi/3600/180;
fi0_rad = fi0 * [3600;60;1] *pi/3600/180;
alfa0 = RA0 * [3600;60;1] *pi/43200;
delta0 = DEC0 * [3600;60;1] *pi/3600/180;
alfa1 = RA1 * [3600;60;1] *pi/43200;
delta1 = DEC1 * [3600;60;1] *pi/3600/180;


% as na UT1 pro den 16.04.2003 (h m s) a potom na radiny
[m,n] = size(zenitky(:,4:6));
UT1 = zeros(m,3);
for ii = 1:m
    UT1(ii,:) = (zenitky(ii,4:6) + t0 + [-TIMEZONE 0 DUT1]);
end

UT1_rad = UT1*[3600;60;1] *pi/43200;
S0_rad = S0*[3600;60;1] *pi/43200;

% interpolace alfa delta
dalfa = alfa1 - alfa0;
ddelta = delta1 - delta0;
TT = UT1_rad/2/pi - DUT1/86400 + TT_UTC/86400;  % terestrick as ve zlomku dne 
alfa = alfa0 + dalfa*TT;
delta = delta0 + ddelta*TT;


% oprava z refrakce zenitek
refrakce_zenitek = refrakce(zenitky_rad,tlak_mmHg*(1013.25/760),teplota);
zenitky_rad = zenitky_rad + refrakce_zenitek;

% vpoet hodinovch hl Slunce
hodin_uhel = UT1_rad*1.00273790935 + S0_rad + lambda0_rad - alfa;

% vpoet azimut z nautickho trojhelnka (potebn pro aberaci a paralaxu)
azimuty = asin(cos(delta).*sin(hodin_uhel)./sin(zenitky_rad));

% denn aberace - zenitky
aberace_zenitek = aberace_z(fi0_rad,azimuty,zenitky_rad);
zenitky_rad = zenitky_rad + aberace_zenitek;

% denn paralaxa - zenitky
paralaxa_zenitek = paralaxa_z(fi0_rad,azimuty,zenitky_rad);
zenitky_rad = zenitky_rad + paralaxa_zenitek;

% vpoet zempisn ky
M = atan2(sin(delta),cos(delta).*cos(hodin_uhel));
fi = M + acos(cos(zenitky_rad) .* sin(M) ./ sin(delta));

fip = mean(fi);


% vpis vsledk
soubor = input('Vstupn soubor (nic pro vpis na obrazovku): ','s');
if isempty(soubor)
    fprintf('\n');
    file = 1;
else
    file = fopen(soubor,'wt');
end

fprintf(file,'Vpoet zempisn ky z men na Slunce (pedmt KG10)\n');
fprintf(file,'Datum vpotu: %s\n',nyni);
fprintf(file,'Datum men:  %02d.%02d.%04d\n',DATUM(3),DATUM(2),DATUM(1));
fprintf(file,'asov zona UTC %+.0f h\n',TIMEZONE);
fprintf(file,'Hodnota DUT1 = %+.5f s\n',DUT1);
fprintf(file,'Nzev vstupnho souboru: %s\n',soubor_vstup);
fprintf(file,'\nSouadnice stanoviska [X Y] (S-JTSK): %.3f  %.3f\n',stanovisko_yx(2),stanovisko_yx(1));
fprintf(file,'Piblin souadnice stanoviska (fi lambda): %s  %s\n',dmsr(fi0_rad,2),dmsr(lambda0_rad,2));
UT1_rad = UT1*[3600;60;1] *pi/3600/12;
fprintf(file,'\nas men UT1, Terestrick as TT, hodinov hel t:\n');
for ii = 1:m
    fprintf(file,'%s     %s     %s\n',hmsr(UT1_rad(ii),2),hmsr(TT(ii)*2*pi,2),hms2r(hodin_uhel(ii),3));
end
fprintf(file,'\nRefrakce, Aberace, Paralaxa na men zenitky:\n');
for ii = 1:m
    fprintf(file,'%s     %s     %s\n',dmsr(refrakce_zenitek(ii),6),dmsr(aberace_zenitek(ii),6),dmsr(paralaxa_zenitek(ii),6));
end
fprintf(file,'\nJednotliv zempisn ky (jednotliv nemaj dn vznam):\n');
for ii = 1:m
    fprintf(file,'%s\n',dmsr(fi(ii),4));
end
fprintf(file,'\nVsledn zempisn ka: %s\n',dmsr(fip,4));


if ~isempty(soubor)
    fclose(file);
else
    fprintf('\n');
end

%EOF